import React from 'react';
import { render } from '@testing-library/react';
import AppContainer from '../AppContainer.js';
describe('AppContainer', () => {
  test('rendering the defult props', () => {
    const {
      asFragment
    } = render( /*#__PURE__*/React.createElement(AppContainer, null));
    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering the customClass', () => {
    const {
      asFragment
    } = render( /*#__PURE__*/React.createElement(AppContainer, {
      className: "AppcontainerClass"
    }));
    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering the needTooltip is false', () => {
    const {
      asFragment
    } = render( /*#__PURE__*/React.createElement(AppContainer, {
      needTooltip: false
    }));
    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering the tooltipClass', () => {
    const {
      asFragment
    } = render( /*#__PURE__*/React.createElement(AppContainer, {
      tooltipClass: "customTooltipClass"
    }));
    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering the tooltipParentClass', () => {
    const {
      asFragment
    } = render( /*#__PURE__*/React.createElement(AppContainer, {
      tooltipParentClass: "tooltipParentClass"
    }));
    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering the Custom props', () => {
    const {
      asFragment
    } = render( /*#__PURE__*/React.createElement(AppContainer, {
      customProps: {
        ExtraProps: {
          'data-props': true
        },
        ContainerProps: {
          'data-container': true
        }
      }
    }));
    expect(asFragment()).toMatchSnapshot();
  });
  test('eleRef prop is a function', () => {
    const mockEleRef = jest.fn();
    render( /*#__PURE__*/React.createElement(AppContainer, {
      eleRef: mockEleRef
    }));
    expect(mockEleRef).toHaveBeenCalled();
  });
  test('rendering the childern as element', () => {
    const {
      asFragment
    } = render( /*#__PURE__*/React.createElement(AppContainer, null, /*#__PURE__*/React.createElement("div", null, "Children")));
    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering the childern as element in array', () => {
    const children = [/*#__PURE__*/React.createElement("div", {
      key: "child1"
    }, "Child 1"), /*#__PURE__*/React.createElement("span", {
      key: "child2"
    }, "Child 2")];
    const {
      asFragment
    } = render( /*#__PURE__*/React.createElement(AppContainer, null, children));
    expect(asFragment()).toMatchSnapshot();
  });
});