import React from 'react';
import { defaultProps } from './props/defaultProps';
import { propTypes } from './props/propTypes';
import { CSSTransition } from 'react-transition-group';
import { animationStyle } from './utils';
export default function Animation(props) {
  let {
    name,
    enterDuration,
    exitDuration,
    children,
    isActive,
    unmountOnExit,
    onEntered = () => {},
    onExit = () => {},
    delayClassName = null
  } = props;
  let newClassNames = delayClassName ? Object.assign({}, animationStyle[name], {
    exit: `${delayClassName} ${animationStyle[name].exit}`
  }) : animationStyle[name];
  return /*#__PURE__*/React.createElement(CSSTransition, {
    classNames: newClassNames && newClassNames,
    in: isActive,
    appear: true,
    enter: true,
    exit: true,
    mountOnEnter: false,
    unmountOnExit: unmountOnExit,
    timeout: {
      enter: enterDuration,
      exit: exitDuration
    },
    onEntered: onEntered,
    onExit: onExit
  }, /*#__PURE__*/React.createElement(React.Fragment, null, children));
}
Animation.propTypes = propTypes;
Animation.defaultProps = defaultProps; // if (__DOCS__) {
//   Animation.docs = {
//     componentGroup: 'Animation',
//     folderName: 'Style Guide',
//     external: true,
//     description: ' '
//   };
// }