import PropTypes from 'prop-types';
export const propTypes = {
  active: PropTypes.bool,
  checked: PropTypes.bool,
  disabled: PropTypes.bool,
  disabledTitle: PropTypes.string,
  getRef: PropTypes.func,
  id: PropTypes.string,
  isFilled: PropTypes.bool,
  isReadOnly: PropTypes.bool,
  labelPalette: PropTypes.oneOf(['default', 'primary', 'danger', 'mandatory']),
  labelSize: PropTypes.oneOf(['small', 'medium', 'large']),
  name: PropTypes.string,
  palette: PropTypes.oneOf(['primary', 'danger']),
  size: PropTypes.oneOf(['small', 'medium']),
  title: PropTypes.string,
  value: PropTypes.string,
  variant: PropTypes.oneOf(['primary', 'default']),
  customClass: PropTypes.shape({
    customRadioWrap: PropTypes.string,
    customRadio: PropTypes.string,
    customLabel: PropTypes.string
  }),
  customProps: PropTypes.exact({
    ContainerProps: PropTypes.object,
    LabelProps: PropTypes.object
  }),
  a11y: PropTypes.shape({
    ariaChecked: PropTypes.bool,
    ariaHidden: PropTypes.bool,
    role: PropTypes.string,
    tabIndex: PropTypes.oneOfType(PropTypes.string, PropTypes.number),
    ariaLabelledby: PropTypes.string,
    ariaLabel: PropTypes.string,
    ariaReadonly: PropTypes.bool
  }),
  children: PropTypes.node,
  onChange: PropTypes.func,
  text: PropTypes.string
};