"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _defaultProps = require("./props/defaultProps");

var _propTypes = require("./props/propTypes");

var _reactTransitionGroup = require("react-transition-group");

var _utils = require("./utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var Animation = /*#__PURE__*/function (_React$Component) {
  _inherits(Animation, _React$Component);

  var _super = _createSuper(Animation);

  function Animation(props) {
    _classCallCheck(this, Animation);

    return _super.call(this, props);
  }

  _createClass(Animation, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          name = _this$props.name,
          enterDuration = _this$props.enterDuration,
          exitDuration = _this$props.exitDuration,
          children = _this$props.children,
          isActive = _this$props.isActive,
          unmountOnExit = _this$props.unmountOnExit,
          _this$props$onEntered = _this$props.onEntered,
          onEntered = _this$props$onEntered === void 0 ? function () {} : _this$props$onEntered,
          _this$props$onExit = _this$props.onExit,
          onExit = _this$props$onExit === void 0 ? function () {} : _this$props$onExit,
          _this$props$delayClas = _this$props.delayClassName,
          delayClassName = _this$props$delayClas === void 0 ? null : _this$props$delayClas;
      var newClassNames = delayClassName ? Object.assign({}, _utils.animationStyle[name], {
        exit: "".concat(delayClassName, " ").concat(_utils.animationStyle[name].exit)
      }) : _utils.animationStyle[name];
      return /*#__PURE__*/_react["default"].createElement(_reactTransitionGroup.CSSTransition, {
        classNames: newClassNames && newClassNames,
        "in": isActive,
        appear: true,
        enter: true,
        exit: true,
        mountOnEnter: false,
        unmountOnExit: unmountOnExit,
        timeout: {
          enter: enterDuration,
          exit: exitDuration
        },
        onEntered: onEntered,
        onExit: onExit
      }, /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, children));
    }
  }]);

  return Animation;
}(_react["default"].Component);

exports["default"] = Animation;
Animation.propTypes = _propTypes.propTypes;
Animation.defaultProps = _defaultProps.defaultProps; // if (__DOCS__) {
//   Animation.docs = {
//     componentGroup: 'Animation',
//     folderName: 'Style Guide',
//     external: true,
//     description: ' '
//   };
// }