"use strict";

var _react = _interopRequireDefault(require("react"));

var _react2 = require("@testing-library/react");

var _AppContainer = _interopRequireDefault(require("../AppContainer.js"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

describe('AppContainer', function () {
  test('rendering the defult props', function () {
    var _render = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_AppContainer["default"], null)),
        asFragment = _render.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering the customClass', function () {
    var _render2 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_AppContainer["default"], {
      className: "AppcontainerClass"
    })),
        asFragment = _render2.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering the needTooltip is false', function () {
    var _render3 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_AppContainer["default"], {
      needTooltip: false
    })),
        asFragment = _render3.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering the tooltipClass', function () {
    var _render4 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_AppContainer["default"], {
      tooltipClass: "customTooltipClass"
    })),
        asFragment = _render4.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering the tooltipParentClass', function () {
    var _render5 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_AppContainer["default"], {
      tooltipParentClass: "tooltipParentClass"
    })),
        asFragment = _render5.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering the Custom props', function () {
    var _render6 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_AppContainer["default"], {
      customProps: {
        ExtraProps: {
          'data-props': true
        },
        ContainerProps: {
          'data-container': true
        }
      }
    })),
        asFragment = _render6.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('eleRef prop is a function', function () {
    var mockEleRef = jest.fn();
    (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_AppContainer["default"], {
      eleRef: mockEleRef
    }));
    expect(mockEleRef).toHaveBeenCalled();
  });
  test('rendering the childern as element', function () {
    var _render7 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_AppContainer["default"], null, /*#__PURE__*/_react["default"].createElement("div", null, "Children"))),
        asFragment = _render7.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering the childern as element in array', function () {
    var children = [/*#__PURE__*/_react["default"].createElement("div", {
      key: "child1"
    }, "Child 1"), /*#__PURE__*/_react["default"].createElement("span", {
      key: "child2"
    }, "Child 2")];

    var _render8 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_AppContainer["default"], null, children)),
        asFragment = _render8.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
});