"use strict";

var _react = _interopRequireDefault(require("react"));

var _CheckBox = _interopRequireDefault(require("../CheckBox"));

var _react2 = require("@testing-library/react");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

describe('CheckBox component', function () {
  test('Should be render with the basic set of default props', function () {
    var _render = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_CheckBox["default"], null)),
        asFragment = _render.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render ID', function () {
    var _render2 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_CheckBox["default"], {
      id: "checkBoxId",
      text: "checkBoxText"
    })),
        asFragment = _render2.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  var palette = ['primary', 'danger'];
  test.each(palette)('Should render palette and checkbox with checked - %s', function (palette) {
    var _render3 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_CheckBox["default"], {
      checked: true,
      palette: palette,
      text: "checkBoxTest",
      active: true
    })),
        asFragment = _render3.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be disable', function () {
    var _render4 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_CheckBox["default"], {
      disabled: true,
      checked: true,
      text: "checkboxDisable"
    })),
        asFragment = _render4.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be isReadOnly', function () {
    var _render5 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_CheckBox["default"], {
      isReadOnly: true
    })),
        asFragment = _render5.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render disabledTitle and title', function () {
    var _render6 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_CheckBox["default"], {
      disabled: true,
      disabledTitle: "checkBoxdisableTitle",
      text: "CheckBoxdisabledTitle",
      title: "checkBoxTitle"
    })),
        asFragment = _render6.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render title', function () {
    var _render7 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_CheckBox["default"], {
      text: "CheckBoxdisabledTitle",
      title: "checkBoxTitle"
    })),
        asFragment = _render7.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render text', function () {
    var _render8 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_CheckBox["default"], {
      text: "CheckBoxdisabledTitle"
    })),
        asFragment = _render8.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  var size = ['small', 'medium'];
  test.each(size)('Should render size - %s', function (size) {
    var _render9 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_CheckBox["default"], {
      checked: true,
      size: size
    })),
        asFragment = _render9.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  var labelPalette = ['default', 'primary', 'secondary', 'danger', 'mandatory'];
  test.each(labelPalette)('Should render size - %s', function (labelPalette) {
    var _render10 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_CheckBox["default"], {
      text: "checkboxText",
      labelPalette: labelPalette
    })),
        asFragment = _render10.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  var labelSize = ['small', 'medium', 'large'];
  test.each(labelSize)('Should render labelSize - %s', function (labelSize) {
    var _render11 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_CheckBox["default"], {
      text: "checkboxText",
      labelSize: labelSize
    })),
        asFragment = _render11.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render isFilled', function () {
    var _render12 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_CheckBox["default"], {
      isFilled: true
    })),
        asFragment = _render12.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render isClipped is false', function () {
    var _render13 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_CheckBox["default"], {
      isClipped: false
    })),
        asFragment = _render13.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('eleRef prop is a function', function () {
    // Create a mock function
    var mockEleRef = jest.fn();

    var _render14 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_CheckBox["default"], {
      getRef: mockEleRef
    })),
        asFragment = _render14.asFragment;

    expect(mockEleRef).toHaveBeenCalled();
  });
  var variant = ['default', 'primary'];
  test.each(variant)('Should render labelSize - %s', function (variant) {
    var _render15 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_CheckBox["default"], {
      text: "checkboxText",
      variant: variant
    })),
        asFragment = _render15.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test.each(palette)('Should render active - %s', function (palette) {
    var _render16 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_CheckBox["default"], {
      text: "checkboxText",
      checked: true,
      active: true,
      palette: palette
    })),
        asFragment = _render16.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render name', function () {
    var _render17 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_CheckBox["default"], {
      name: "checkBoxName"
    })),
        asFragment = _render17.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render activeStyle is minus', function () {
    var _render18 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_CheckBox["default"], {
      activeStyle: "minus"
    })),
        asFragment = _render18.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render dataSelectorId', function () {
    var _render19 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_CheckBox["default"], {
      dataSelectorId: "dataSelectorIdCheck"
    })),
        asFragment = _render19.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering the Custom Props', function () {
    var _render20 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_CheckBox["default"], {
      text: "checkboxText",
      customProps: {
        CheckBoxProps: {
          'data-props': true
        },
        LabelProps: {
          'customClass': 'checkBoxCustomClass'
        }
      }
    })),
        asFragment = _render20.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering the Custom class', function () {
    var _render21 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_CheckBox["default"], {
      text: "checkboxText",
      checked: true,
      customClass: {
        customCheckBox: 'customCheckBoxClass',
        customLabel: 'customLabelClass',
        customCBoxSize: 'customCBoxSizeClass',
        customTickSize: 'customTickSizeClass'
      }
    })),
        asFragment = _render21.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering ally ariaLabel , ariaLabelledby, ariaHidden,ariaChecked,role  true and entering their values', function () {
    var _render22 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_CheckBox["default"], {
      checked: true,
      a11y: {
        ariaLabel: 'ariaLabelCheckBox',
        ariaLabelledby: 'ariaLabelledbyCheckBox',
        ariaChecked: true,
        ariaHidden: true,
        role: 'checkBox2'
      }
    })),
        asFragment = _render22.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering ally ariaLabel , ariaLabelledby, ariaHidden,ariaChecked,role  false and entering their values', function () {
    var _render23 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_CheckBox["default"], {
      checked: true,
      a11y: {
        ariaLabel: 'ariaLabelCheckBox',
        ariaLabelledby: 'ariaLabelledbyCheckBox',
        ariaChecked: false,
        ariaHidden: false,
        role: 'checkBox3'
      }
    })),
        asFragment = _render23.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
});