"use strict";

var _react = _interopRequireDefault(require("react"));

var _Tag = _interopRequireDefault(require("../Tag"));

var _react2 = require("@testing-library/react");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

describe('Tag component', function () {
  var size = ['small', 'medium'];
  var palette = ['default', 'danger', 'secondary', 'pureDotted', 'primaryDotted', 'dark', 'pureDarkDotted', 'darkPrimaryDotted', 'defaultLink'];
  var closePalette = ['danger', 'primary'];
  test('Should be render with the basic set of default props', function () {
    var _render = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Tag["default"], null)),
        asFragment = _render.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render imageURL and hasAvatar', function () {
    var _render2 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Tag["default"], {
      hasAvatar: true,
      imageURL: "https://www.w3schools.com/images/w3schools_green.jpg"
    })),
        asFragment = _render2.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render text', function () {
    var _render3 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Tag["default"], {
      text: "TagTest"
    })),
        asFragment = _render3.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render initial', function () {
    var _render4 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Tag["default"], {
      hasAvatar: true,
      initial: "avatarIntial"
    })),
        asFragment = _render4.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test.each(size)('Should render size  - %s', function (size) {
    var _render5 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Tag["default"], {
      size: size
    })),
        asFragment = _render5.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test.each(size)('Should render onRemove - %s', function (size) {
    var mockOnRemove = jest.fn();

    var _render6 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Tag["default"], {
      active: true,
      size: size,
      onRemove: mockOnRemove
    })),
        asFragment = _render6.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  size.map(function (sz) {
    closePalette.map(function (cp) {
      test.each(palette)("Should render active - palette %s, size ".concat(sz, " , closePalette ").concat(cp), function (palette) {
        var mockOnRemove = jest.fn();

        var _render7 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Tag["default"], {
          active: true,
          size: sz,
          palette: palette,
          onRemove: mockOnRemove,
          closePalette: cp
        })),
            asFragment = _render7.asFragment;

        expect(asFragment()).toMatchSnapshot();
      });
    });
  });
  test('Should be render rounded is false', function () {
    var mockOnRemove = jest.fn();

    var _render8 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Tag["default"], {
      onRemove: mockOnRemove,
      rounded: false
    })),
        asFragment = _render8.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test.each(palette)('Should render palette - %s', function (palette) {
    var _render9 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Tag["default"], {
      hasAvatar: true,
      active: true,
      palette: palette
    })),
        asFragment = _render9.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render disabled is true', function () {
    var _render10 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Tag["default"], {
      disabled: true
    })),
        asFragment = _render10.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render disabled is false', function () {
    var _render11 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Tag["default"], {
      disabled: false
    })),
        asFragment = _render11.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test.each(closePalette)('Should render closePalette - %s', function (closePalette) {
    var mockOnRemove = jest.fn();

    var _render12 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Tag["default"], {
      onRemove: mockOnRemove,
      active: true,
      closePalette: closePalette
    })),
        asFragment = _render12.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render onSelectTag', function () {
    var mockonSelectTag = jest.fn();

    var _render13 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Tag["default"], {
      onSelectTag: mockonSelectTag
    })),
        asFragment = _render13.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render closeTitle', function () {
    var mockOnRemove = jest.fn();

    var _render14 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Tag["default"], {
      onRemove: mockOnRemove,
      closeTitle: "TagCloseTitle"
    })),
        asFragment = _render14.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render dataId when active if false', function () {
    var mockOnRemove = jest.fn();

    var _render15 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Tag["default"], {
      onRemove: mockOnRemove,
      dataId: "TagdataId"
    })),
        asFragment = _render15.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render dataId when active if true', function () {
    var mockOnRemove = jest.fn();

    var _render16 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Tag["default"], {
      active: true,
      onRemove: mockOnRemove,
      dataId: "TagdataId"
    })),
        asFragment = _render16.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render iconName and iconSize', function () {
    var _render17 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Tag["default"], {
      iconName: "ZD-androidd",
      iconSize: "15"
    })),
        asFragment = _render17.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render tooltip', function () {
    var _render18 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Tag["default"], {
      tooltip: "Tagtooltip"
    })),
        asFragment = _render18.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test.each(palette)('Should render avatarPalette - %s', function (palette) {
    var _render19 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Tag["default"], {
      hasAvatar: true,
      palette: palette,
      avatarPalette: "primary"
    })),
        asFragment = _render19.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render needEffect is false', function () {
    var _render20 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Tag["default"], {
      needEffect: false
    })),
        asFragment = _render20.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render isReadOnly is true', function () {
    var _render21 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Tag["default"], {
      isReadOnly: true
    })),
        asFragment = _render21.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering the Custom class', function () {
    var mockOnRemove = jest.fn();

    var _render22 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Tag["default"], {
      onRemove: mockOnRemove,
      iconName: "ZD-androidd",
      hasAvatar: true,
      customClass: {
        customTag: 'customCustomTag',
        customTagClose: 'customCustomTagClose',
        customTagIcon: 'customCustomTagIcon',
        customAvatar: 'customCustomAvatar'
      }
    })),
        asFragment = _render22.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering ally clearLabel', function () {
    var mockOnRemove = jest.fn();

    var _render23 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Tag["default"], {
      onRemove: mockOnRemove,
      a11y: {
        clearLabel: 'TagClearLabel'
      }
    })),
        asFragment = _render23.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
});