"use strict";

var _react = _interopRequireDefault(require("react"));

var _Textbox = _interopRequireDefault(require("../Textbox"));

var _react2 = require("@testing-library/react");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

describe('Textbox component', function () {
  var type = ['text', 'password', 'number'];
  var size = ['small', 'xsmall', 'medium', 'xmedium'];
  var variant = ['primary', 'secondary', 'default', 'light'];
  var borderColor = ['transparent', 'default'];
  test('Should be render with the basic set of default props', function () {
    var _render = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textbox["default"], null)),
        asFragment = _render.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test.each(type)('Should render type  - %s', function (type) {
    var _render2 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textbox["default"], {
      type: type
    })),
        asFragment = _render2.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render name', function () {
    var _render3 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textbox["default"], {
      name: "TextboxName"
    })),
        asFragment = _render3.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render id', function () {
    var _render4 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textbox["default"], {
      id: "TextboxId"
    })),
        asFragment = _render4.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render maxLength in number', function () {
    var _render5 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textbox["default"], {
      maxLength: "11"
    })),
        asFragment = _render5.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render maxLength in string', function () {
    var _render6 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textbox["default"], {
      maxLength: "Ten"
    })),
        asFragment = _render6.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render placeholder', function () {
    var _render7 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textbox["default"], {
      placeHolder: "TextBoxPlaceHolder"
    })),
        asFragment = _render7.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test.each(size)('Should render size  - %s', function (size) {
    var _render8 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textbox["default"], {
      size: size
    })),
        asFragment = _render8.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render isReadOnly is true and needEffect is true', function () {
    var _render9 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textbox["default"], {
      isReadOnly: true,
      needEffect: true
    })),
        asFragment = _render9.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render isReadOnly is true and needEffect is false', function () {
    var _render10 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textbox["default"], {
      isReadOnly: true,
      needEffect: false
    })),
        asFragment = _render10.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render isReadOnly is false and needEffect is false', function () {
    var _render11 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textbox["default"], {
      isReadOnly: false,
      needEffect: false
    })),
        asFragment = _render11.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render isDisabled is true and needEffect is true', function () {
    var _render12 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textbox["default"], {
      isDisabled: true,
      needEffect: true
    })),
        asFragment = _render12.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render isDisabled is true and needEffect is false', function () {
    var _render13 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textbox["default"], {
      isDisabled: true,
      needEffect: false
    })),
        asFragment = _render13.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render isDisabled is false and needEffect is false', function () {
    var _render14 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textbox["default"], {
      isDisabled: false,
      needEffect: false
    })),
        asFragment = _render14.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test.each(variant)('Should render Varient - %s', function (variant) {
    var _render15 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textbox["default"], {
      variant: variant
    })),
        asFragment = _render15.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render needBorder is false  ', function () {
    var _render16 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textbox["default"], {
      needBorder: false
    })),
        asFragment = _render16.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render value in number', function () {
    var _render17 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textbox["default"], {
      value: 20
    })),
        asFragment = _render17.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render value in string', function () {
    var _render18 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textbox["default"], {
      value: "Tewnty"
    })),
        asFragment = _render18.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render needReadOnlyStyle is false and isReadOnly true ', function () {
    var _render19 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textbox["default"], {
      needReadOnlyStyle: false,
      isReadOnly: true
    })),
        asFragment = _render19.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render needReadOnlyStyle is false  ', function () {
    var _render20 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textbox["default"], {
      needReadOnlyStyle: false
    })),
        asFragment = _render20.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render needReadOnlyStyle is true and isReadOnly true  ', function () {
    var _render21 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textbox["default"], {
      needReadOnlyStyle: true,
      isReadOnly: true
    })),
        asFragment = _render21.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render needAppearance is false ', function () {
    var _render22 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textbox["default"], {
      needAppearance: false
    })),
        asFragment = _render22.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render isClickable is ture ', function () {
    var _render23 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textbox["default"], {
      isClickable: true
    })),
        asFragment = _render23.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render autofocus false ', function () {
    var _render24 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textbox["default"], {
      autofocus: false
    })),
        asFragment = _render24.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render autofocus true ', function () {
    var _render25 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textbox["default"], {
      autofocus: true
    })),
        asFragment = _render25.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render autoComplete true ', function () {
    var _render26 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textbox["default"], {
      autoComplete: true
    })),
        asFragment = _render26.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render autoComplete false ', function () {
    var _render27 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textbox["default"], {
      autoComplete: false
    })),
        asFragment = _render27.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test.each(borderColor)('Should render borderColor - %s', function (borderColor) {
    var _render28 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textbox["default"], {
      borderColor: borderColor
    })),
        asFragment = _render28.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render htmlId ', function () {
    var _render29 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textbox["default"], {
      htmlId: "textBoxhtmlId"
    })),
        asFragment = _render29.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render isFocus is true ', function () {
    var _render30 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textbox["default"], {
      isFocus: true
    })),
        asFragment = _render30.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render isScrollPrevent is true ', function () {
    var _render31 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textbox["default"], {
      isScrollPrevent: true
    })),
        asFragment = _render31.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering ally ariaExpanded,ariaHaspopup,ariaRequired,ariaLabelledby,ariaReadonly,ariaMultiselectable is true', function () {
    var _render32 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textbox["default"], {
      a11y: {
        ariaLabel: 'textboxAriaLabel',
        ariaAutocomplete: 'textboxAriaAutocomplete',
        ariaControls: 'textboxAriaControls',
        ariaExpanded: true,
        role: 'TextboxRole',
        ariaDescribedby: 'textboxAriaDescribedby',
        ariaHaspopup: true,
        ariaRequired: true,
        ariaLabelledby: 'textboxAriaLabelledby',
        ariaInvalid: true,
        ariaOwns: 'textboxAriaOwns',
        ariaActivedescendant: 'textBoxAriaActivedescendant',
        ariaReadonly: true,
        ariaMultiselectable: true
      }
    })),
        asFragment = _render32.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering ally ariaExpanded,ariaHaspopup,ariaRequired,ariaLabelledby,ariaReadonly,ariaMultiselectable is false', function () {
    var _render33 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textbox["default"], {
      a11y: {
        ariaLabel: 'textboxAriaLabel',
        ariaAutocomplete: 'textboxAriaAutocomplete',
        ariaControls: 'textboxAriaControls',
        ariaExpanded: false,
        role: 'TextboxRole',
        ariaDescribedby: 'textboxAriaDescribedby',
        ariaHaspopup: false,
        ariaRequired: false,
        ariaLabelledby: 'textboxAriaLabelledby',
        ariaInvalid: false,
        ariaOwns: 'textboxAriaOwns',
        ariaActivedescendant: 'textBoxAriaActivedescendant',
        ariaReadonly: false,
        ariaMultiselectable: false
      }
    })),
        asFragment = _render33.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render customClass ', function () {
    var _render34 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textbox["default"], {
      customClass: "TextBoxCustomClass"
    })),
        asFragment = _render34.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering the Custom Props', function () {
    var _render35 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textbox["default"], {
      customProps: {
        'textbox-props': "true"
      }
    })),
        asFragment = _render35.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
});