"use strict";

var _react = _interopRequireDefault(require("react"));

var _TextBoxIcon = _interopRequireDefault(require("../TextBoxIcon"));

var _react2 = require("@testing-library/react");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

describe('TextBoxIcon component', function () {
  var type = ['text', 'password', 'number'];
  var size = ['small', 'xsmall', 'medium', 'xmedium'];
  var variant = ['primary', 'secondary', 'default'];
  var borderColor = ['transparent', 'default', 'error'];
  test('Should be render with the basic set of default props', function () {
    var _render = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_TextBoxIcon["default"], null)),
        asFragment = _render.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test.each(type)('Should render type  - %s', function (type) {
    var _render2 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_TextBoxIcon["default"], {
      type: type
    })),
        asFragment = _render2.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render name', function () {
    var _render3 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_TextBoxIcon["default"], {
      name: "TextBoxIconName"
    })),
        asFragment = _render3.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render id', function () {
    var _render4 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_TextBoxIcon["default"], {
      id: "TextboxIconId"
    })),
        asFragment = _render4.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render placeholder', function () {
    var _render5 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_TextBoxIcon["default"], {
      placeHolder: "TextBoxIconPlaceHolder"
    })),
        asFragment = _render5.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test.each(size)('Should render size  - %s', function (size) {
    var _render6 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_TextBoxIcon["default"], {
      size: size
    })),
        asFragment = _render6.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render isDisabled is true', function () {
    var _render7 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_TextBoxIcon["default"], {
      isDisabled: true
    })),
        asFragment = _render7.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render isReadOnly is true', function () {
    var _render8 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_TextBoxIcon["default"], {
      isReadOnly: true
    })),
        asFragment = _render8.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render isReadOnly is true , needEffect is false', function () {
    var _render9 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_TextBoxIcon["default"], {
      isReadOnly: true,
      needEffect: false
    })),
        asFragment = _render9.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render children', function () {
    var _render10 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_TextBoxIcon["default"], null, " ", /*#__PURE__*/_react["default"].createElement("div", null, "test"), " ")),
        asFragment = _render10.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render value is string and length greater than 1', function () {
    var mockOnClear = jest.fn();

    var _render11 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_TextBoxIcon["default"], {
      value: "Text",
      onClear: mockOnClear
    })),
        asFragment = _render11.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render value is number', function () {
    var mockOnClear = jest.fn();

    var _render12 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_TextBoxIcon["default"], {
      value: 10,
      onClear: mockOnClear
    })),
        asFragment = _render12.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render value is string and length less than 1', function () {
    var mockOnClear = jest.fn();

    var _render13 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_TextBoxIcon["default"], {
      value: "0",
      onClear: mockOnClear
    })),
        asFragment = _render13.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render iconRotated is true', function () {
    var _render14 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_TextBoxIcon["default"], {
      iconRotated: true
    }, " ", /*#__PURE__*/_react["default"].createElement("div", null, "test"), " ")),
        asFragment = _render14.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render needBorder is false', function () {
    var _render15 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_TextBoxIcon["default"], {
      needBorder: false
    })),
        asFragment = _render15.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test.each(variant)('Should render Varient - %s', function (variant) {
    var _render16 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_TextBoxIcon["default"], {
      variant: variant
    })),
        asFragment = _render16.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render title', function () {
    var _render17 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_TextBoxIcon["default"], {
      title: "TextBoxIconTitle",
      isDisabled: true
    })),
        asFragment = _render17.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render needReadOnlyStyle is false', function () {
    var _render18 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_TextBoxIcon["default"], {
      needReadOnlyStyle: false
    })),
        asFragment = _render18.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render isClickable is true', function () {
    var _render19 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_TextBoxIcon["default"], {
      isClickable: true
    })),
        asFragment = _render19.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render needEffect is false', function () {
    var _render20 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_TextBoxIcon["default"], {
      isReadOnly: true,
      needEffect: false
    })),
        asFragment = _render20.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test.each(borderColor)('Should render borderColor - %s', function (borderColor) {
    var _render21 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_TextBoxIcon["default"], {
      borderColor: borderColor
    })),
        asFragment = _render21.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render showClearIcon is true', function () {
    var _render22 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_TextBoxIcon["default"], {
      showClearIcon: true
    })),
        asFragment = _render22.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render htmlId ', function () {
    var _render23 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_TextBoxIcon["default"], {
      htmlId: "textBoxIconhtmlId"
    })),
        asFragment = _render23.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render iconOnHover is true , iconOnHover, isDisabled is true ', function () {
    var _render24 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_TextBoxIcon["default"], {
      iconOnHover: true,
      isReadOnly: true,
      isDisabled: true
    })),
        asFragment = _render24.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render iconOnHover is true , iconOnHover, isDisabled is false ', function () {
    var _render25 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_TextBoxIcon["default"], {
      iconOnHover: true,
      isReadOnly: false,
      isDisabled: false
    })),
        asFragment = _render25.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render isFocus is true  ', function () {
    var _render26 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_TextBoxIcon["default"], {
      isFocus: true,
      isActive: true
    })),
        asFragment = _render26.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering the Custom class', function () {
    var _render27 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_TextBoxIcon["default"], {
      needBorder: true,
      customClass: {
        customTBoxWrap: 'customTBoxWrapTextBoxIcon',
        customTextBox: 'customTextBoxTextBoxIcon',
        customTBoxIcon: 'customTBoxIconTextBox',
        customTBoxLine: 'customTBoxLineTextBox'
      }
    })),
        asFragment = _render27.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering the Custom Props', function () {
    var _render28 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_TextBoxIcon["default"], {
      text: "checkboxText",
      customProps: {
        TextBoxProps: {
          'isClickable': 'false'
        }
      }
    })),
        asFragment = _render28.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering the i18n value', function () {
    var mockOnClear = jest.fn();
    var i18nKeys = {
      clearText: 'TextBoxIcon Text'
    };

    var _render29 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_TextBoxIcon["default"], {
      value: "Text",
      onClear: mockOnClear,
      i18nKeys: i18nKeys
    })),
        asFragment = _render29.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
});