"use strict";

var _react = _interopRequireDefault(require("react"));

var _Textarea = _interopRequireDefault(require("../Textarea"));

var _react2 = require("@testing-library/react");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

describe('Textarea component', function () {
  var size = ['xsmall', 'small', 'xmedium', 'medium', 'large'];
  var resize = ['horizontal', 'vertical', 'both', 'none'];
  var variant = ['default', 'primary'];
  var borderColor = ['transparent', 'default'];
  test('Should be render with the basic set of default props', function () {
    var _render = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textarea["default"], null)),
        asFragment = _render.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test.each(size)('Should render size  - %s', function (size) {
    var _render2 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textarea["default"], {
      size: size,
      animated: true
    })),
        asFragment = _render2.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render placeholder', function () {
    var _render3 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textarea["default"], {
      placeHolder: "TextAreaPlaceHolder"
    })),
        asFragment = _render3.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render needBorder is false', function () {
    var _render4 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textarea["default"], {
      needBorder: false
    })),
        asFragment = _render4.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render text', function () {
    var _render5 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textarea["default"], {
      text: "TextAreaText"
    })),
        asFragment = _render5.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render isDisabled is true', function () {
    var _render6 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textarea["default"], {
      isDisabled: true,
      needEffect: false
    })),
        asFragment = _render6.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test.each(resize)('Should render resize  - %s', function (resize) {
    var _render7 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textarea["default"], {
      resize: resize
    })),
        asFragment = _render7.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render maxLength in number', function () {
    var _render8 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textarea["default"], {
      maxLength: "11"
    })),
        asFragment = _render8.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render maxLength in string', function () {
    var _render9 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textarea["default"], {
      maxLength: "Ten"
    })),
        asFragment = _render9.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test.each(size)('Should render animated is true - %s', function (size) {
    var _render10 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textarea["default"], {
      size: size,
      animated: true
    })),
        asFragment = _render10.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test.each(size)('Should render animated is false - %s', function (size) {
    var _render11 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textarea["default"], {
      size: size,
      animated: false
    })),
        asFragment = _render11.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test.each(variant)('Should render Varient - %s', function (variant) {
    var _render12 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textarea["default"], {
      variant: variant
    })),
        asFragment = _render12.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('to render eleRef prop is a function', function () {
    // Create a mock function
    var mockEleRef = jest.fn();
    (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textarea["default"], {
      getRef: mockEleRef
    }));
    expect(mockEleRef).toHaveBeenCalled();
  });
  test('Should be render isReadOnly is true and needEffect is true', function () {
    var _render13 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textarea["default"], {
      isReadOnly: true,
      needEffect: true
    })),
        asFragment = _render13.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render isReadOnly is true and needEffect is false', function () {
    var _render14 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textarea["default"], {
      isReadOnly: true,
      needEffect: false
    })),
        asFragment = _render14.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render isReadOnly is false and needEffect is false', function () {
    var _render15 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textarea["default"], {
      isReadOnly: false,
      needEffect: false
    })),
        asFragment = _render15.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render isDisabled is true and needEffect is true', function () {
    var _render16 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textarea["default"], {
      isDisabled: true,
      needEffect: true
    })),
        asFragment = _render16.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render isDisabled is true and needEffect is false', function () {
    var _render17 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textarea["default"], {
      isDisabled: true,
      needEffect: false
    })),
        asFragment = _render17.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render isDisabled is false and needEffect is false', function () {
    var _render18 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textarea["default"], {
      isDisabled: false,
      needEffect: false
    })),
        asFragment = _render18.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render autofocus true ', function () {
    var _render19 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textarea["default"], {
      autoFocus: true
    })),
        asFragment = _render19.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render needAppearance is false ', function () {
    var _render20 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textarea["default"], {
      needAppearance: false
    })),
        asFragment = _render20.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render needReadOnlyStyle is false ', function () {
    var _render21 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textarea["default"], {
      needReadOnlyStyle: false
    })),
        asFragment = _render21.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test.each(borderColor)('Should render borderColor - %s', function (borderColor) {
    var _render22 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textarea["default"], {
      borderColor: borderColor
    })),
        asFragment = _render22.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render htmlId ', function () {
    var _render23 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textarea["default"], {
      htmlId: "textAreahtmlId"
    })),
        asFragment = _render23.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('rendering ally clearLabel', function () {
    var _render24 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textarea["default"], {
      a11y: {
        ariaLabel: 'TextAreaAriaLabel',
        ariaLabelledby: 'TexareaAriaLabelledby'
      }
    })),
        asFragment = _render24.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
  test('Should be render customClass ', function () {
    var _render25 = (0, _react2.render)( /*#__PURE__*/_react["default"].createElement(_Textarea["default"], {
      customClass: "textAreaCustomClass"
    })),
        asFragment = _render25.asFragment;

    expect(asFragment()).toMatchSnapshot();
  });
});