"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = Modal;

var _react = _interopRequireWildcard(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _useEffectCallOnlyAfterState = _interopRequireDefault(require("@zohodesk/hooks/es/utils/useEffectCallOnlyAfterState"));

var _defaultProps = require("./props/defaultProps");

var _propTypes = require("./props/propTypes");

var _AppContainerModule = _interopRequireDefault(require("../../AppContainer/AppContainer.module.css"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var createdPortalIds = [];
var newPortalPrefix = 'CPortal';
var portalChildrenTopIndexValues;

function Modal(props) {
  var children = props.children,
      isActive = props.isActive,
      autoZIndexNeeded = props.autoZIndexNeeded,
      propPortalId = props.portalId;

  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      isMounted = _useState2[0],
      setMounted = _useState2[1];

  var portalId = (0, _react.useRef)(propPortalId);
  var ref = (0, _react.useRef)(null);
  var isZIndexAppendNeeded = (0, _react.useRef)();
  var zIndex = (0, _react.useRef)();
  var modalRoot = (0, _react.useRef)();
  var newModalRoot = (0, _react.useRef)();
  var containerDiv = (0, _react.useRef)();
  var portalDiv = (0, _react.useRef)(); // document.createDocumentFragment()

  var isCustomPortalId = (0, _react.useRef)();
  var setRef = (0, _react.useCallback)(function (ele) {
    ref.current = ele;

    if (isZIndexAppendNeeded.current) {
      ref.current.style.zIndex = zIndex.current;
      isZIndexAppendNeeded.current = false;
    }
  }, []);

  function getPortalDiv() {
    modalRoot.current = propPortalId ? document.querySelector("[data-portal=".concat(propPortalId, "]")) : "";

    if (!modalRoot.current) {
      portalId.current = handleAddPortalId();
      newModalRoot.current = document.createElement('div');
      newModalRoot.current.className = _AppContainerModule["default"].container;
      newModalRoot.current.setAttribute('data-portal', portalId.current);
      containerDiv.current && containerDiv.current.appendChild(newModalRoot.current);
      modalRoot.current = newModalRoot.current;
    }

    return modalRoot.current;
  }

  (0, _react.useEffect)(function () {
    containerDiv.current = document.getElementsByTagName("desk")[0] ? document.getElementsByTagName('desk')[0] : document.getElementsByTagName('body')[0];
    portalDiv.current = getPortalDiv();
    setMounted(true);
    setTimeout(function () {
      handleInsertPortalDiv();
    });
    return function () {
      // modalRoot.current && modalRoot.current.removeChild(portalDiv.current);
      if (newModalRoot.current) {
        containerDiv.current && containerDiv.current.removeChild(newModalRoot.current);
        handleRemovePortalId();
      }

      if (zIndex.current && portalChildrenTopIndexValues === zIndex.current) {
        portalChildrenTopIndexValues -= 1;
      }
    };
  }, []);
  (0, _useEffectCallOnlyAfterState["default"])(function () {
    if (isActive) {
      handleInsertPortalDiv();
    } else if (zIndex.current && portalChildrenTopIndexValues === zIndex.current) {
      portalChildrenTopIndexValues -= 1;
    }
  }, [isActive]);

  function handleInsertPortalDiv() {
    if (autoZIndexNeeded && isActive) {
      var newHighValue = Number(portalChildrenTopIndexValues || 10) + 1;
      portalChildrenTopIndexValues = newHighValue;
      zIndex.current = newHighValue;

      if (ref.current) {
        ref.current.style.zIndex = newHighValue;
      } else {
        isZIndexAppendNeeded.current = true;
      }
    }
  }

  function handleAddPortalId() {
    var createdPortalIdsLen = createdPortalIds.length;
    var newPortalId = createdPortalIdsLen ? createdPortalIds[createdPortalIdsLen - 1] + 1 : 1;
    createdPortalIds.push(newPortalId);
    portalId.current = newPortalId;
    isCustomPortalId.current = true;
    return "".concat(newPortalPrefix).concat(newPortalId);
  }

  function handleRemovePortalId() {
    if (isCustomPortalId.current) {
      createdPortalIds = createdPortalIds.filter(function (id) {
        return id !== portalId.current;
      });
    }
  }

  var Element = children.type,
      elementProps = children.props;

  if (isMounted) {
    if (Element) {
      return /*#__PURE__*/_reactDom["default"].createPortal( /*#__PURE__*/_react["default"].createElement(Element, _extends({
        ref: setRef
      }, elementProps)), portalDiv.current);
    }

    return null;
  }

  return null;
}

Modal.defaultProps = _defaultProps.defaultProps;
Modal.propTypes = _propTypes.propTypes;